=== Tests/RunCMake/file/subdir_test_unlock/CMakeLists.txt ===
message(STATUS "Lock in subdirectory")
file(LOCK "${lfile}" GUARD FILE)
